﻿using System;
using CodeContractsExample;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace CodeContractsExampleTests
{
    [TestClass]
    public class TeacherTests
    {
        private readonly Teacher _teacher = new Teacher("Anders");

        [TestMethod]
        public void ConstructorTest()
        {
            Assert.AreEqual("Anders", _teacher.Name);
            Assert.AreEqual(0, _teacher.Salary);
            try
            {
                new Teacher("");
                Assert.Fail();
            }
            catch (Exception) { }

            try
            {
                new Teacher(null);
                Assert.Fail();
            }
            catch (Exception) { }
        }

        [TestMethod]
        public void NameTest()
        {
            _teacher.Name = "John";
            Assert.AreEqual("John", _teacher.Name);
            try
            {
                _teacher.Name = null;
                Assert.Fail();
            }
            catch (Exception) { }

            try
            {
                _teacher.Name = "";
                Assert.Fail();
            }
            catch (Exception) { }
        }

        [TestMethod]
        public void RaiseSalaryToTest()
        {
            _teacher.RaiseSalaryTo(100);
            try
            {
                _teacher.RaiseSalaryTo(99);
                Assert.Fail();
            }
            catch (Exception ex)
            {
                Assert.IsTrue(ex.Message.StartsWith("Precondition"));
            }
        }

        [TestMethod]
        public void LowerSalaryToTest()
        {
            _teacher.Salary = 100;
            _teacher.LowerSalaryTo(99);
            try
            {
                _teacher.LowerSalaryTo(100);
                Assert.Fail();
            }
            catch (ArgumentOutOfRangeException ex)
            {
                Assert.IsTrue(ex.Message.StartsWith("Precondition"));
            }
        }
    }
}
